#pragma once

#include "Configuration.h"

class __declspec(uuid("{C132E8CE-DB3F-4aa9-884A-82334BC39CBF}")) CConfStrage
	: public IConfNamedStrage
	, public CComObjectRoot
{
public:
	BEGIN_COM_MAP(CConfStrage)
		COM_INTERFACE_ENTRY(IConfNamedStrage)
		COM_INTERFACE_ENTRY(IConfStrage)
	END_COM_MAP( )

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct() throw();

	HRESULT Init(LPCWSTR v_pSectionName, LPCWSTR v_pIniFilePath) throw();

	void FinalRelease() throw();

	/// IConfStrage ///

	virtual HRESULT __stdcall GetInt(LPCWSTR v_pName, int v_default, int* v_pValue) throw();

	virtual HRESULT __stdcall WriteInt(LPCWSTR v_pName, int v_value) throw();

	virtual HRESULT __stdcall GetString(LPCWSTR v_pName, LPCWSTR v_pDefault, BSTR* v_pValue) throw();

	virtual HRESULT __stdcall WriteString(LPCWSTR v_pName, LPCWSTR v_pValue) throw();

	virtual HRESULT __stdcall GetData(LPCWSTR v_pName, LPVOID v_pData, size_t v_siz) throw();

	virtual HRESULT __stdcall WriteData(LPCWSTR v_pName, LPVOID v_pData, size_t v_siz) throw();

	virtual HRESULT __stdcall EnumEntries(IConfStrageEnumEntries** v_ppEnumEntries) throw();

	/// IConfNamedStrage ///

	virtual HRESULT __stdcall GetName(BSTR* v_pName) throw();

private:

	friend class CConfStrageEnumEntries;

	CAtlString iniFilePath_;

	CAtlString sectionName_;
};
